 /*
 * file      : src/page.c
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by Claude BULIN
 *
 * TM - Edition des heures de travail / Edition of working hours
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
	#define gettext_noop(x) (x) 
#endif

#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_tm/lib.h"
#endif

#include "global.h"
#include "callbacks.h"


/*
typedef struct {
	gint	NbrPages;					// Nombre total de pages
	gint	NbrLines;					// Nombre total de lignes
	GList	*Page;						// struct LINE_OF_PAGE
} PAGES_VIEW;
*/
ALL_MONTH AllMonth = {
	{1,0,NULL},	// AllPages_Janvier
	{1,0,NULL},	// AllPages_Fevrier
	{1,0,NULL},	// AllPages_Mars
	{1,0,NULL},	// AllPages_Avril
	{1,0,NULL},	// AllPages_Mai
	{1,0,NULL},	// AllPages_Juin
	{1,0,NULL},	// AllPages_Juillet
	{1,0,NULL},	// AllPages_Aout
	{1,0,NULL},	// AllPages_Septembre
	{1,0,NULL},	// AllPages_Octobre
	{1,0,NULL},	// AllPages_Novembre
	{1,0,NULL}	// AllPages_Decembre
};


// 
//
void page_search_posX_ps( GList *p_PageMonth )
{
	GList		*ListPages = NULL;
	LINE_OF_PAGE	*Details = NULL;
	gint		HeightPage = _SIZE_ONE_PAGE_;
	gint		Page = 0;
	
	if( NULL != p_PageMonth ) {
		ListPages = g_list_first( p_PageMonth );
		while( ListPages ) {
			if( NULL != (Details = (LINE_OF_PAGE *)ListPages->data) ) {
				
				if( (Details->LineType & BEGIN_PAGE) == BEGIN_PAGE) {
					Page ++;
				}
				Details->PosYPS = ((Page * HeightPage) - (gint)Details->PosY);
			}
			ListPages = g_list_next( ListPages );
		}
	}
}
// 
//
void page_get( gint p_Month, GList **p_PageMonth, gint **p_NbrPages, gint **p_NbrLinesPerPage )
{
	// LE MOIS EN COURS
	switch( p_Month ) {
	case 0 :
		*p_PageMonth       = AllMonth.Pages_Janvier.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Janvier.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Janvier.NbrPages;
		break;
	case 1 :
		*p_PageMonth       = AllMonth.Pages_Fevrier.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Fevrier.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Fevrier.NbrPages;
		break;
	case 2 :
		*p_PageMonth       = AllMonth.Pages_Mars.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Mars.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Mars.NbrPages;
		break;
	case 3 :
		*p_PageMonth       = AllMonth.Pages_Avril.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Avril.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Avril.NbrPages;
		break;
	case 4 :
		*p_PageMonth       = AllMonth.Pages_Mai.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Mai.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Mai.NbrPages;
		break;
	case 5 :
		*p_PageMonth       = AllMonth.Pages_Juin.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Juin.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Juin.NbrPages;
		break;
	case 6 :
		*p_PageMonth       = AllMonth.Pages_Juillet.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Juillet.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Juillet.NbrPages;
		break;
	case 7 :
		*p_PageMonth       = AllMonth.Pages_Aout.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Aout.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Aout.NbrPages;
		break;
	case 8 :
		*p_PageMonth       = AllMonth.Pages_Septembre.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Septembre.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Septembre.NbrPages;
		break;
	case 9 :
		*p_PageMonth       = AllMonth.Pages_Octobre.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Octobre.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Octobre.NbrPages;
		break;
	case 10 :
		*p_PageMonth       = AllMonth.Pages_Novembre.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Novembre.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Novembre.NbrPages;
		break;
	case 11 :
		*p_PageMonth       = AllMonth.Pages_Decembre.Page;
		*p_NbrLinesPerPage = &AllMonth.Pages_Decembre.NbrLines;
		*p_NbrPages        = &AllMonth.Pages_Decembre.NbrPages;
		break;
	}
}
// 
//
gint page_get_NbrPages( guint p_Month )
{
	GList 			*PageMonth = NULL;
	gint			*NbrPages = NULL;
	gint			*NbrLinesPerPage = NULL;
	
	page_get( p_Month, &PageMonth, &NbrPages, &NbrLinesPerPage );
	
	return( *NbrPages );
}
// 
// 
GList *page_list_remove( GList *p_list_page )
{
	GList		*ListPages = NULL;
	LINE_OF_PAGE	*Details = NULL;
	
	if( NULL != p_list_page ) {
		ListPages = g_list_first( p_list_page );
		while( ListPages ) {
			if( NULL != (Details = (LINE_OF_PAGE *)ListPages->data)) {
				if( NULL != Details->Str ) {
					g_free( Details->Str );
					Details->Str = NULL;
				}
				g_free( Details );
				Details = ListPages->data = NULL;
			}
			ListPages = g_list_next( ListPages );
		}
		g_list_free( p_list_page );
		p_list_page = NULL;
	}
	return ((GList*)NULL );
}
// 0 .. 11
void page_select_list_remove( gint p_MonthBegin, gint p_MonthEnd )
{
	gint	CptMonth;
	
	for( CptMonth = p_MonthBegin; CptMonth <= p_MonthEnd; CptMonth ++ ) {
		switch( CptMonth ) {
		case  0: AllMonth.Pages_Janvier.Page   = page_list_remove( AllMonth.Pages_Janvier.Page );	break;
		case  1: AllMonth.Pages_Fevrier.Page   = page_list_remove( AllMonth.Pages_Fevrier.Page );	break;
		case  2: AllMonth.Pages_Mars.Page      = page_list_remove( AllMonth.Pages_Mars.Page );		break;
		case  3: AllMonth.Pages_Avril.Page     = page_list_remove( AllMonth.Pages_Avril.Page );		break;
		case  4: AllMonth.Pages_Mai.Page       = page_list_remove( AllMonth.Pages_Mai.Page );		break;
		case  5: AllMonth.Pages_Juin.Page      = page_list_remove( AllMonth.Pages_Juin.Page );		break;
		case  6: AllMonth.Pages_Juillet.Page   = page_list_remove( AllMonth.Pages_Juillet.Page );	break;
		case  7: AllMonth.Pages_Aout.Page      = page_list_remove( AllMonth.Pages_Aout.Page );		break;
		case  8: AllMonth.Pages_Septembre.Page = page_list_remove( AllMonth.Pages_Septembre.Page );	break;
		case  9: AllMonth.Pages_Octobre.Page   = page_list_remove( AllMonth.Pages_Octobre.Page );	break;
		case 10: AllMonth.Pages_Novembre.Page  = page_list_remove( AllMonth.Pages_Novembre.Page );	break;
		case 11: AllMonth.Pages_Decembre.Page  = page_list_remove( AllMonth.Pages_Decembre.Page );	break;
		}
	}
}
void page_all_list_remove( void )
{
	/*AllMonth.Pages_Janvier.Page   = page_list_remove( AllMonth.Pages_Janvier.Page );
	AllMonth.Pages_Fevrier.Page   = page_list_remove( AllMonth.Pages_Fevrier.Page );
	AllMonth.Pages_Mars.Page      = page_list_remove( AllMonth.Pages_Mars.Page );
	AllMonth.Pages_Avril.Page     = page_list_remove( AllMonth.Pages_Avril.Page );
	AllMonth.Pages_Mai.Page       = page_list_remove( AllMonth.Pages_Mai.Page );
	AllMonth.Pages_Juin.Page      = page_list_remove( AllMonth.Pages_Juin.Page );
	AllMonth.Pages_Juillet.Page   = page_list_remove( AllMonth.Pages_Juillet.Page );
	AllMonth.Pages_Aout.Page      = page_list_remove( AllMonth.Pages_Aout.Page );
	AllMonth.Pages_Septembre.Page = page_list_remove( AllMonth.Pages_Septembre.Page );
	AllMonth.Pages_Octobre.Page   = page_list_remove( AllMonth.Pages_Octobre.Page );
	AllMonth.Pages_Novembre.Page  = page_list_remove( AllMonth.Pages_Novembre.Page );
	AllMonth.Pages_Decembre.Page  = page_list_remove( AllMonth.Pages_Decembre.Page );*/
	page_select_list_remove( 0, 11 );
}
// 
//
guint page_get_month( void )
{
	guint 	year, month, day;
	
	gtk_calendar_get_date( GTK_CALENDAR(VarCallbacks.Adr_Calendar), &year, &month, &day );
	return( month );
}
// 
//
LINE_OF_PAGE *page_struct_alloc( LINE_TYPE p_LineType )
{
	LINE_OF_PAGE	*Details = NULL;
	
	Details = (LINE_OF_PAGE *)g_malloc0( sizeof( LINE_OF_PAGE ));
	// INIT Details ...
	Details->LineType       = p_LineType;
	Details->PosX           = 0.0;
	Details->PosY           = 0.0;
	Details->PosXPS         = 0.0;
	Details->PosYPS         = 0.0;
	Details->TypeColor      = COLOR_BLACK;
	Details->FontSlantType  = FONT_SLANT_NORMAL;
	Details->FontWeightType = FONT_WEIGHT_NORMAL;
	Details->SizeFont       = VarDraw.SizeFontName;
	Details->Str            = NULL;
	
	return( (LINE_OF_PAGE *)Details );
}
void page_line_alloc( GList **p_list_page, LINE_TYPE p_LineType )
{
	LINE_OF_PAGE	*Details = NULL;
	
	Details = (LINE_OF_PAGE *)g_malloc0( sizeof( LINE_OF_PAGE ));
	// INIT Details ...
	Details->LineType       = p_LineType;
	Details->PosX           = 0.0;
	Details->PosY           = 0.0;
	Details->PosXPS         = 0.0;
	Details->PosYPS         = 0.0;
	Details->TypeColor      = COLOR_BLACK;
	Details->FontSlantType  = FONT_SLANT_NORMAL;
	Details->FontWeightType = FONT_WEIGHT_NORMAL;
	Details->SizeFont       = VarDraw.SizeFontName;
	Details->Str            = NULL;
	*p_list_page = g_list_append( *p_list_page, Details );
}
// 
// 
void page_add_PosX( GList *p_list_page, gdouble p_PosX )
{
	LINE_OF_PAGE	*Details = NULL;
	GList		*LastListOfPages = NULL;

	LastListOfPages = g_list_last( p_list_page );
	Details = (LINE_OF_PAGE *)LastListOfPages->data;
	Details->PosX   = p_PosX;
	Details->PosXPS = p_PosX;
}
// 
// 
void page_add_font_color( GList *p_list_page, TYPE_COLOR p_TypeColor )
{
	LINE_OF_PAGE	*Details = NULL;
	GList		*LastListOfPages = NULL;

	LastListOfPages = g_list_last( p_list_page );
	Details = (LINE_OF_PAGE *)LastListOfPages->data;
	Details->TypeColor = p_TypeColor;
}
// 
//
void page_add_font_slant( GList *p_list_page, FONT_SLANT_TYPE p_FontSlantType )
{
	LINE_OF_PAGE	*Details = NULL;
	GList		*LastListOfPages = NULL;

	LastListOfPages = g_list_last( p_list_page );
	Details = (LINE_OF_PAGE *)LastListOfPages->data;
	Details->FontSlantType = p_FontSlantType;
}
// 
//
void page_add_font_weight( GList *p_list_page, FONT_WEIGHT_TYPE p_FontWeightType )
{
	LINE_OF_PAGE	*Details = NULL;
	GList		*LastListOfPages = NULL;

	LastListOfPages = g_list_last( p_list_page );
	Details = (LINE_OF_PAGE *)LastListOfPages->data;
	Details->FontWeightType = p_FontWeightType;
}
// 
//
void page_add_str( GList *p_list_page, gchar *p_Str )
{
	LINE_OF_PAGE	*Details = NULL;
	GList		*LastListOfPages = NULL;

	LastListOfPages = g_list_last( p_list_page );
	Details = (LINE_OF_PAGE *)LastListOfPages->data;
	// if( NULL == Details->Str )
	Details->Str = g_strdup( p_Str );
}









