 /*
 * file      : src/translate.c
 * project   : tm
 * with      : Gtk-2
 *
 * copyright : (C) 2012 by BULIN Claude
 *
 * TM
 *     Traduction des chaines du fichier *.glade
 *     Translate string of *.glade file
 * GNU General Public License
 * 
 * This file is part of TM.
 * 
 * TM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 * 
 * TM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with TM.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifdef HAVE_CONFIG_H
	#include "../config.h"
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif

#include <gtk/gtk.h>

#ifdef ENABLE_STATIC_LIBRARY
	#include "../lib_tm/lib.h"
#endif

void translate_glade (void)
{
	typedef struct {
		gchar	*string;
	} TRANS;

	TRANS trans[] = {

	{ _("Fichier") },
	{ _("Aide") },
	{ _("Choix d'une nouvelle annee") },
	{ _("Ouvrir un fichier existant") },
	{ _("Exporter vers ...") },
	{ _("Parametres de la base") },
	{ _("<i><b>Choisissez une annee ou ouvrez une base existante</b></i>") },
	{ _("<b>Matin debut</b>") },
	{ _("<b>Matin fin</b>") },
	{ _("<b>Soir debut</b>") },
	{ _("<b>Soir fin</b>") },
	{ _("<b>Commentaire</b>") },
	{ _("<b>Nombre d'heures par semaine</b>") },
	{ _("zoom") },
	{ _("<b>Quitter</b>") },
	{ _("<b>Emplacement et nom du nouveau fichier</b>") },
	{ _("<b>Choix d'une annee pour le nouveau fichier</b>") },
	{ _("<b>Ok</b>") },
	{ _("<b>Annuler</b>") },
	{ _("Janvier") },
	{ _("Fevrier") },
	{ _("Mars") },
	{ _("Avril") },
	{ _("Mai") },
	{ _("Juin") },
	{ _("Juillet") },
	{ _("Aout") },
	{ _("Septembre") },
	{ _("Octobre") },
	{ _("Novembre") },
	{ _("Decembre") },
	{ _("<b>Choix du mois</b>") },
	{ _("button") },
	{ _("<b>Destination</b>") },
	{ _("PDF") },
	{ _("PNG") },
	{ _("PS") },
	{ _("TXT") },
	{ _("<b>Formats d'exportation</b>") },
	{ _("<b>Ok</b>") },
	{ _("<b>Appliquer</b>") },
	{ _("<b>Annuler</b>") },
	{ _("<b>Choix jour</b>") },
	{ _("<b>Matin debut et fin</b>") },
	{ _("<b>Soir debut et fin</b>") },
	{ _("<b>Ajuste les horaires pour une semaine</b>") },
	{ _("<b>Appliquer les modifications sur</b>") },
	{ _("<b>Ok</b>") },
	{ _("<b>Appliquer</b>") },
	{ _("<b>Cancel</b>") },
	{ _("A propos de TM") },
	{ _("\nEdition des heures de travail.") }


	};

	if (*trans [ 0 ] . string);
}

